use std::{
    marker::PhantomData,
    io::Write
};


use haskell_ffi::{
    error::Result,
    from_haskell::marshall_from_haskell_var,
    to_haskell::marshall_to_haskell_var,
    FromHaskell, ToHaskell
};

use borsh::{BorshDeserialize, BorshSerialize};

pub enum RW {}
pub const RW: PhantomData<RW> = PhantomData;

#[derive(Debug, BorshSerialize, BorshDeserialize)]
pub struct Hhex {
    bytes: Vec<u8>
}

impl<RW> ToHaskell<RW> for Hhex {
    fn to_haskell<W: Write>(&self, writer: &mut W, _tag: PhantomData<RW>) -> Result<()> {
        self.serialize(writer)?;
        Ok(())
    }
}

impl<RW> FromHaskell<RW> for Hhex {
    fn from_haskell(buf: &mut &[u8], _tag: PhantomData<RW>) -> Result<Self> {
        let x = Hhex::deserialize(buf)?;
        Ok(x)
    }
}

#[no_mangle]
pub extern "C" fn marshalling_test (
    input: *const u8,
    input_len: usize,
    out: *mut u8,
    out_len: &mut usize
){
    let x: Vec<u8> = marshall_from_haskell_var(input, input_len, RW);
    marshall_to_haskell_var(&x, out, out_len, RW);
}
